/*
 * Buffer for storing packages coming from a Package Producer
 *
 * Copyright (C) 2003  Enrico Zini <enrico@debian.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#pragma implementation

#include "PackageBuffer.h"
#include "DebtagsPackage.h"

#include <algorithm>
#include <functional>

using namespace std;

struct less_pkg : public binary_function<Debtags::Package*, Debtags::Package*, bool> {
	bool operator()(Debtags::Package* x, Debtags::Package* y) { return x->name() < y->name(); }
};

void PackageBuffer::consume(Debtags::Package* pkg) throw ()
{
	if (cap == 0 || size() < cap)
		push_back(pkg);
	else
		_discarded++;
}

void PackageBuffer::sort() throw ()
{
	::sort(begin(), end(), less_pkg());
}

// vim:set ts=4 sw=4:
