#ifndef PACKAGE_BUFFER_H
#define PACKAGE_BUFFER_H

/*
 * Buffer for storing packages coming from a Package Producer
 *
 * Copyright (C) 2003  Enrico Zini <enrico@debian.org>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#pragma interface

#include "DebtagsConsumer.h"

#include <vector>

class PackageBuffer : public std::vector<Debtags::Package*>, public Debtags::PackageConsumer
{
protected:
	unsigned int cap;
	int _discarded;
	
public:
	PackageBuffer(unsigned int cap = 0) throw () : cap(cap), _discarded(0) {}
	virtual ~PackageBuffer() throw () {}
	
	virtual void consume(Debtags::Package* pkg) throw ();
	
	int discarded() const throw () { return _discarded; }
	
	void sort() throw ();
};

// vim:set ts=4 sw=4:
#endif
